;**********************************************************************
;     (-27)
; :   (AlexAlcoa@yandex.ru)
;**********************************************************************
;  : 14.03.2008
;**********************************************************************
; : +
; 17.11.2008. Rev 1.1 -   "".
; 19.07.2010. Rev 1.2 -     ( "" 
;						       )
;**********************************************************************
	list		p=12f675				; 
	#include	<p12f675.inc>			; 

	errorlevel  -302					;     

 __CONFIG   _CP_OFF & _CPD_OFF & _BODEN_ON & _MCLRE_OFF & _WDT_ON & _PWRTE_ON & _INTRC_OSC_NOCLKOUT
          ;              MCLR           
          ;                               
          ;                                                
;**********************************************************************
;   
#define	Ifb				GPIO,0			;     
#define	Ufb				GPIO,1			;    
#define	Gate_VT			GPIO,2			;    
#define	RUN_SET			GPIO,3			;  ( MCLR)
#define	Key_fors		GPIO,4			;   
#define	Led_speed		GPIO,5			;   
;**********************************************************************
;    0x20  0x3F (63 .)
 cblock    0x20
			w_temp						;   W
			status_temp					;   STATUS
			Flag_reg					;  
			Temp_reg					;  
			Temp_reg_1					;
			SP_lo_hi					;     Low->High
			SP_hi_lo					;     High->Low
			Ramp_reg					;    
			Curr_ADC					;    
			Delay_SW					;     
			Delay_MTO					;     
			Del_1S_HI					;   
			Del_1S_ME					;  
			Del_1S_LO					;
			ADC_sym_HI					;   
			ADC_sym_LO					;   
			CNT_sampl					;    
; .
			AARGB0						;
			AARGB1						;
			AARGB5						;
			BARGB0						;
			BARGB1						;
			TEMP						;
			REMB0						;
			LOOPCOUNT					;
 endc
;**********************************************************************
;  
 constant	PL_TMR0		= .136			;    (.136=250uS; .11=500uS)
 constant	Uref_LO		= b'10100001'	;    " "
 constant	Uref_HI		= b'10101111'	;    " "
 constant	Ramp_SP		= .40			;    Vref (N * 0.25mS)
 constant	Del_swich	= .60			;     (N * 0.25mS)
 constant	MTO_SP		= .200			;     ()
 constant	MTO_delay	= .1			;     (N * 0.25mS)
 constant	Per_hi		= .25			; "%"       
										;    hi->lo
 constant	Per_lo		= .17			; "%"       
										;    lo->hi
;**********************************************************************
;  
#define	Fl_speed		Flag_reg,0		;   
#define	Auto_SW_Q		Flag_reg,1		;  ""  
#define	Man_SW_Q		Flag_reg,2		;  ""  
#define	Ov_current		Flag_reg,3		;    
#define	Auto_setting	Flag_reg,4		;   
;**********************************************************************
	ORG	0x000						;  
		goto	Start				;    	
;**********************************************************************
;  
;**********************************************************************
	ORG	0x004						;  
		movwf	w_temp				;  
		movf	STATUS,w			; 
		movwf	status_temp			; W  STATUS
		bcf		STATUS,RP0			;  0
		movlw	PL_TMR0				;  TMR0
		movwf	TMR0				;
		clrwdt						;  
;====================================
;    
;     
;====================================
Read_curr							;
		bsf		ADCON0,GO_DONE		;   ADC (  )
; ""  
		bcf		Man_SW_Q			; Key_fors = 0?
		btfss	Key_fors			;  Man_SW_Q =1
		bsf		Man_SW_Q			; Man_SW_Q =0 
		btfsc	Auto_setting		; ?
		bcf		Man_SW_Q			; Man_SW_Q=0
Wait_ADC_CURR						;   ADC 
		btfsc	ADCON0,GO_DONE		;
		goto	Wait_ADC_CURR		;
		bsf		STATUS,RP0			; 
		movfw	ADRESL^80h			; ADRESL  urr_ADC        
		bcf		STATUS,RP0			;
		movwf	Curr_ADC			;
;====================================
;     
;====================================
MTO_SW								;
		movfw	ADRESH				;
		btfss	STATUS,Z			; ADRESH =0?
		goto	Ower_yes_cur		; ,   "Ower_yes_cur"
		movlw	MTO_SP				; Curr_ADC >= MTO_SP?
		subwf	Curr_ADC,w			; ,   "Ower_yes_cur"
		btfsc	STATUS,C			;, 
		goto	Ower_yes_cur		; ,   "End_auto_SW"
Ower_no_cur							;
		bcf		Ov_current			;   
		movlw	MTO_delay			;   
		movwf	Delay_MTO			;  
		goto	End_MTO_SW			;   End_MTO_SW.
Ower_yes_cur						;
		decfsz	Delay_MTO,f			; Delay_MTO-1 = 0?
		goto	End_MTO_SW			;,   End_MTO_SW.
		bsf		Ov_current			; ,   
		goto	Decode_flag			;   "Decode_flag"
End_MTO_SW							;
;====================================
;    
;====================================
Auto_SW								;
		btfsc	Man_SW_Q			; Man_SW_Q=1?
		goto	End_auto_SW			;    "End_auto_SW".  
		btfsc	Auto_SW_Q			; Auto_SW_Q=1?
		goto	HI_to_LO			; .    HI_to_LO
LO_to_HI							;
		movfw	SP_lo_hi			; Curr_ADC >= SP_lo_hi?
		subwf	Curr_ADC,w			;,   "Res_del_swich"
		btfss	STATUS,C			; , Delay_SW - 1 = 0?
		goto	Res_del_swich		; ,   "End_auto_SW"
		decfsz	Delay_SW,f			; , Auto_SW_Q = 1
		goto	End_auto_SW			;    "Res_del_swich"
		bsf		Auto_SW_Q			;		
		goto	Res_del_swich		;
HI_to_LO							;
		movfw	Curr_ADC			;
		subwf	SP_hi_lo,w			; Curr_ADC =< SP_hi_lo
		btfss	STATUS,C			;,   "Res_del_swich"
		goto	Res_del_swich		; , Delay_SW - 1 = 0?
		decfsz	Delay_SW,f			; ,   "End_auto_SW"
		goto	End_auto_SW			; , Auto_SW_Q = 0  
		bcf		Auto_SW_Q			;
Res_del_swich						;
		movlw	Del_swich			;   
		movwf	Delay_SW			;   
End_auto_SW							;
;====================================
;   
;====================================
Decode_flag							; Fl_speed = 0
		bcf		Fl_speed			;   ?    Mod_Vref
		btfsc	Ov_current			; 
		goto	Mod_Vref			;	
		btfsc	Man_SW_Q			;    ?  Fl_speed=1 
		bsf		Fl_speed			;    Fl_speed=1  .  
		btfsc	Auto_SW_Q			;
		bsf		Fl_speed			;    ?  Fl_speed=1 
End_decode_flag						;    Fl_speed=1  .  
;====================================
;   / Vref
; Fl_speed = 1  Vref  [Uref_HI]
; Fl_speed = 0  Vref  [Uref_LO]
;    Ramp_SP
;====================================
Mod_Vref							;
		decfsz	Ramp_reg,f			;   Vref  Ramp_reg = 0
		goto	End_mod_Vref		; 
		movlw	Ramp_SP				;  ,  
		movwf	Ramp_reg			;  , 
;    Vref  Temp_reg
		bsf		STATUS,RP0			;
        movfw   VRCON^80h			;
		bcf		STATUS,RP0			;
        movwf	Temp_reg			;
		btfss	Fl_speed			;   
		goto	Decr_speed			;
; Vref  Uref_HI
Incr_speed							;
		movlw	Uref_HI				; Vref >= Uref_HI
		subwf	Temp_reg,w			;  .
		btfsc	STATUS,C			; 
		goto	End_mod_Vref		;		
		incf	Temp_reg,w			;    Vref 
		goto	Write_Vref			;  	
; Vref  Uref_LO
Decr_speed							;
		movfw	Temp_reg			; Vref =< Uref_LO
		sublw	Uref_LO				;  .
		btfsc	STATUS,C			; 	
		goto	End_mod_Vref		;	
		decf	Temp_reg,w			;    Vref  
;   Vref
Write_Vref							;
		bsf		STATUS,RP0			;  1
        movwf   VRCON^80h			;  
		bcf		STATUS,RP0			;  0
End_mod_Vref						;
;====================================
Exit_int							;
		bcf		INTCON,T0IF			; .    TMR0 
		movf	status_temp,w		; 
		movwf	STATUS				; 
		swapf	w_temp,f			; 
		swapf	w_temp,w			; W  STATUS
		retfie						;   
;******************************************************************************
; , 
;******************************************************************************
;    
;====================================
Ind_HI_on	macro					;
		bsf		STATUS,RP0			;  1
		bcf		TRISIO^80h,5		;     
		bcf		STATUS,RP0			;  0
		bcf		Led_speed			;   
		endm						;
;====================================
;    
;====================================
Ind_LO_on	macro					;
		bsf		STATUS,RP0			;  1
		bcf		TRISIO^80h,5		;     	
		bcf		STATUS,RP0			;  0
		bsf		Led_speed			;   
		endm						;
;====================================
;  
;====================================
Ind_OFF		macro					;
		bsf		STATUS,RP0			;  1
		bsf		TRISIO^80h,5		;     
		bcf		STATUS,RP0			;  0
		endm						;
;====================================
;   1  (4MHz)
;====================================
Delay_1sec							;
		movlw	.173				;
		movwf	Del_1S_LO			;
		movlw	.15					;
		movwf	Del_1S_ME			;
		movlw	.5					;
		movwf	Del_1S_HI			;
D1S_loop							;
		clrwdt						;
		decfsz	Del_1S_LO,f			;
		goto	D1S_loop			;
		decfsz	Del_1S_ME,f			;
		goto	D1S_loop			;
		decfsz	Del_1S_HI,f			;
		goto	D1S_loop			;
		return						;
;====================================
;   0.250  (4MHz)
;====================================
Delay_250ms							;
		movlw	.253				;
		movwf	Del_1S_LO			;
		movlw	.244				;
		movwf	Del_1S_ME			;
		movlw	.1					;
		movwf	Del_1S_HI			;
D500ms_loop							;
		clrwdt						;
		decfsz	Del_1S_LO,f			;
		goto	D500ms_loop			; 
		decfsz	Del_1S_ME,f			;	
		goto	D500ms_loop			; 
		decfsz	Del_1S_HI,f			;
		goto	D500ms_loop			; 
		return						;
;====================================
;  ADC     ADC_sym[HI:LO]
;====================================
Rd_sym_ADC							;
		bsf		ADCON0,GO_DONE		;  ADC (  )
Wait_RSADC							;
		btfsc	ADCON0,GO_DONE		;
		goto	Wait_RSADC			;
		bsf		STATUS,RP0			;    ADRES[L:H]
		movfw	ADRESL^80h			;   
		bcf		STATUS,RP0			;
		addwf	ADC_sym_LO,f		;     ADC_sym[HI:LO]
		movfw	ADRESH				;
		btfsc	STATUS,C			;
		incf	ADRESH,w			;
		addwf	ADC_sym_HI,f		;
		return						;
;====================================
;    EEPROM ( W   )
; :     "W"
; :  "W"  
;====================================
Read_EEPROM							;
		bsf		STATUS,RP0			;  1
		movwf	EEADR				;		
		bsf		EECON1,RD			;
		movfw	EEDATA				;
		bcf		STATUS,RP0			;  0
		return						;
;====================================
;   "%"    ADC_sym_LO
;   "W"  "%"
;   AARGB1
;====================================
Calc_percent						;
		movwf	BARGB0				;  "%"
		movfw	ADC_sym_LO			;  
		movwf	AARGB0				;
		call	FXM0808U			;AARGB0 * BARGB0 -> AARGB0:AARGB1
		movlw	.100				;
		movwf	BARGB0				;AARGB0:AARGB1/100 -> AARGB0:AARGB1
		call	FXD1608U			; "%"  AARGB1
		retlw	0x00				;
;====================================
;   (8/8) AARGB0 * BARGB0 -> AARGB0,AARGB1
; Max Timing:     1+70+2 = 73 clks
; Min Timing:     1+53 = 54 clks
; PM: 1+19+1 = 21	   DM: 4
;   AN617 (Fixed Point Routines)
;====================================
FXM0808U							;
		clrf	AARGB1       		;
		movlw	0x08				;
		movwf	LOOPCOUNT			;
		movfw	AARGB0				;
LOOPUM0808A							;
		rrf		BARGB0,f			;
		btfsc	STATUS,C			;
		goto	LUM0808NAP			;
		decfsz	LOOPCOUNT,f			;
		goto	LOOPUM0808A			;
		clrf	AARGB0				;
		retlw	0x00				;
LUM0808NAP							;
		bcf		STATUS,C			;
		goto	LUM0808NA			;
LOOPUM0808							;
		rrf		BARGB0,f			;
		btfsc	STATUS,C			;
		addwf	AARGB0,f			;
LUM0808NA							;
		rrf		AARGB0,f			;
		rrf		AARGB1,f			;
		decfsz	LOOPCOUNT,f			;
		goto	LOOPUM0808			;
		retlw	0x00				;
;====================================
;   (16/8) AARGB0:AARGB1 / BARGB0 -> AARGB0:AARGB1, REMB0
; Max Timing:     1+291+2 = 294 clks
; Min Timing:     1+227+2 = 230 clks
; FLASH: 1+39+1 = 41         DM: 7
;   AN617 (Fixed Point Routines)
;====================================
FXD1608U							;
		clrf	REMB0				;
		MOVLW	0x08				;
		MOVWF	LOOPCOUNT			;
LOOPU1608A							;
		RLF	  	AARGB0,W			;
		RLF	  	REMB0, F			;
		MOVF	BARGB0,W			;
		SUBWF	REMB0, F			;
		BTFSC	STATUS,C			;
		GOTO	UOK68A   			;       
		ADDWF	REMB0, F			;
		BCF		STATUS,C			;
UOK68A								;
		RLF		AARGB0, F			;
		DECFSZ	LOOPCOUNT, F		;
		GOTO	LOOPU1608A			;
		CLRF	TEMP				;
		MOVLW	0x08				;
		MOVWF	LOOPCOUNT			;
LOOPU1608B							;
		RLF		AARGB1,W			;
		RLF		REMB0, F			;
		RLF		TEMP, F				;
		MOVF	BARGB0,W			;
		SUBWF	REMB0, F			;
		CLRF	AARGB5				;
		CLRW						;
		BTFSS	STATUS,C			;
		INCFSZ	AARGB5,W			;
		SUBWF	TEMP, F				;
		BTFSC	STATUS,C			;
		GOTO	UOK68B    			;      
		MOVF	BARGB0,W			;
		ADDWF	REMB0, F			;
		CLRF	AARGB5				;
		CLRW						;
		BTFSC	STATUS,C			;
		INCFSZ	AARGB5,W			;
		ADDWF	TEMP, F				;
		BCF		STATUS,C			;
UOK68B								;
		RLF		AARGB1, F			;
		DECFSZ	LOOPCOUNT, F		;
		GOTO	LOOPU1608B			;
		retlw	0x00				;
;******************************************************************************
;  
;******************************************************************************
;  
;******************************************************************************
Start								;
		clrwdt						;
		call	0x3FF				;    
		bsf		STATUS,RP0			;  1
		movwf	OSCCAL^80h			;    
		bcf		STATUS,RP0			;  0
		clrf	GPIO				;   
		clrf	TMR0				;  TMR0 
		movlw	B'00000000'			;  
		movwf	INTCON				;
		movlw	B'00000000'			;    TMR1
		movwf	T1CON				;
		bsf		STATUS,RP0			;  1
		movlw	B'00011011'			;   I/O
		movwf	TRISIO^80h			; 0-, 1-
		movlw	B'00000011'			; AN<3:0>   
		movwf	ANSEL^80h			; 0-. , 1- 
		movlw	B'00010000'			;   TMR0, K=1/2,  
		movwf	OPTION_REG^80h		;  , . . .
		movlw	B'00010000'			;  . 
		movwf	WPU					; 0-, 1-
		movlw	B'00000000'			;    . -
		movwf	PIE1^80h			;
		bcf		STATUS,RP0			;  0
		movlw	B'10000001'			;    "0"
		movwf	ADCON0				;
;  
		movlw	Ramp_SP				;   
		movwf	Ramp_reg			;  
		movlw	MTO_delay			;   
		movwf	Delay_MTO			;   
		movlw	0x00				;   
		call	Read_EEPROM			;  Low->High
		movwf	SP_lo_hi			;
		movlw	0x01				;   
		call	Read_EEPROM			;  High->Low
		movwf	SP_hi_lo			;
		clrf	Flag_reg			;   
;    Vref
		bsf		STATUS,RP0			;  1
		movlw	Uref_HI				;     
		movwf   VRCON^80h			;  "" 
		bcf		STATUS,RP0			;  0
		bcf		Fl_speed			; Fl_speed = 0 ( )
		movlw	B'00000011'			;    "011"
		movwf	CMCON				;
		Ind_HI_on					;   	
		call	Delay_1sec			;   
		call	Delay_1sec			;
;    
		btfss	RUN_SET				; RUN_SET =1?  
		goto	Auto_set			;   Auto_set
;  
		movfw	SP_hi_lo			; SP_lo_hi = SP_hi_lo?
		subwf	SP_lo_hi,w			;  ""
		btfsc	STATUS,Z			; 
		goto	Error_auto_set		; SP_lo_hi < SP_hi_lo?
		btfsc	STATUS,C			; ""
		goto	Error_auto_set		;  	
;  TMR0
		movlw	PL_TMR0				;  TMR0
		movwf	TMR0				;
		movlw	b'10100000'			;  
		movwf	INTCON				;  TMR0 
;******************************************************************************
;   
Main_loop							;
		clrwdt						;
		btfsc	RUN_SET				;   ?
		goto	ML_led_service		;, .  
		bcf		INTCON,GIE			; 
		movlw	b'00000000'			;   "000"
		movwf	CMCON				;
		bcf		Gate_VT				; 
		goto	StopMotor			;  StopMotor
ML_led_service						;
		btfss	Fl_speed			; Fl_speed = 1 (  ?)
		goto	Led_LO_speed		; ,    
Led_HI_speed						;,    
		Ind_HI_on					;
		goto	Main_loop			;
Led_LO_speed						;
		Ind_LO_on					;
		goto	Main_loop			;
;******************************************************************************
;   
StopMotor							;
		clrwdt						;
		btfss	RUN_SET				;  ?
		goto	StopMotor			;, 
WaitMotor							;
		Ind_OFF						;
		call	Delay_250ms			; !!!
		btfss	RUN_SET				;      
		goto	StartMotor			;
		call	Delay_250ms			;
		btfss	RUN_SET				;
		goto	StartMotor			;
		Ind_LO_on					;
		call	Delay_250ms			;
		btfss	RUN_SET				;
		goto	StartMotor			;
		call	Delay_250ms			;
		btfsc	RUN_SET				;
		goto	WaitMotor			;
StartMotor							;
		Ind_OFF						;
WaitPullBtn							;
		clrwdt						;  ?
		btfss	RUN_SET				;, 
		goto	WaitPullBtn			;
	banksel		VRCON				; !!!  MAX
		movlw	Uref_HI				; 1
		movwf	VRCON				;
	banksel		CMCON				;
		bcf		Fl_speed			;
		movlw	B'00000011'			;
		movwf	CMCON				;
   		movf	Del_swich,W			;
		movwf	Delay_SW			;
		Ind_HI_on					;
		call	Delay_1sec			;
		bsf		INTCON,GIE			; 
		goto	Main_loop			;  Main_loop
;******************************************************************************
;  
Auto_set							;
;====================================
;      
		bsf		Auto_setting			;   
		Ind_HI_on					;    	
		bsf		STATUS,RP0			;  1		
		movlw	Uref_HI				;     
		movwf   VRCON^80h			;
		bcf		STATUS,RP0			;  0
		call	Delay_1sec			;  2.
		call	Delay_1sec			;
		clrf	ADC_sym_HI			;   
		clrf	ADC_sym_LO			;  
		movlw	.32					;    
		movwf	CNT_sampl			;
;     
HI_speed_loop
		call	Delay_250ms			;  0,25
		call	Rd_sym_ADC			;  ADC   
		btfss	CNT_sampl,0			;
		goto	HSL_led_ON			;
HSL_led_OFF							;
		Ind_OFF						;  
		goto	HSL_end_loop		;	
HSL_led_ON							;
		Ind_HI_on					;    
HSL_end_loop						;
		decfsz	CNT_sampl,f			;  ?
		goto	HI_speed_loop		;   "HI_speed_loop".  
;  
		Ind_OFF						;  
		clrwdt						;
		bcf		STATUS,C			; /2
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;	
		bcf		STATUS,C			; /4
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		bcf		STATUS,C			; /8
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		bcf		STATUS,C			; /16
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		bcf		STATUS,C			; /32
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		btfsc	STATUS,C			; 0.5   1-
		incf	ADC_sym_LO,f		;
		movlw	0x00				; ADC_sym_HI =0?
		subwf	ADC_sym_HI,w		;  
		btfss	STATUS,Z			;     Error_auto_set
		goto	Error_auto_set		;
;     Per_hi
		movlw	Per_hi				;   "%"
		call	Calc_percent		; 
		movfw	AARGB1				;
		addwf	ADC_sym_LO,w		;   "%"  ADC_sym_LO		
;    EEPROM
		bsf		STATUS,RP0			;  1
		movwf	EEDATA				;
		movlw	0x01				;
		movwf	EEADR				;		
		bsf		EECON1,WREN			;
		bcf		INTCON,GIE			;
		movlw	0x55				;
		movwf	EECON2				;
		movlw	0xAA				;
		movwf	EECON2				;
		bsf		EECON1,WR			;
AS_wait1							;
		clrwdt						;
		btfsc	EECON1,WR			;
		goto	AS_wait1			;
		bcf		STATUS,RP0			;  0
;====================================
;      
		Ind_LO_on					;    
		bsf		STATUS,RP0			;  1		
		movlw	Uref_LO				;     
		movwf   VRCON^80h			;
		bcf		STATUS,RP0			;  0
		call	Delay_1sec			;
		call	Delay_1sec			;
		call	Delay_1sec			;
		call	Delay_1sec			;
		clrf	ADC_sym_HI			;
		clrf	ADC_sym_LO			;
		movlw	.32					;    
		movwf	CNT_sampl			;
;     
LO_speed_loop						;
		call	Delay_250ms			;  0,25
		call	Rd_sym_ADC			;  ADC   
		btfss	CNT_sampl,0			;
		goto	LSL_led_ON			;
LSL_led_OFF							;
		Ind_OFF						;  
		goto	LSL_end_loop		;	
LSL_led_ON							;
		Ind_LO_on					;    
LSL_end_loop						;
		decfsz	CNT_sampl,f			;  ?
		goto	LO_speed_loop		;   "LO_speed_loop".  
;  
		Ind_OFF						;  
		clrwdt						;
		bcf		STATUS,C			; /2
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;	
		bcf		STATUS,C			; /4
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		bcf		STATUS,C			; /8
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		bcf		STATUS,C			; /16
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		bcf		STATUS,C			; /32
		rrf		ADC_sym_HI,f		;
		rrf		ADC_sym_LO,f		;
		btfsc	STATUS,C			; 0.5   1-
		incf	ADC_sym_LO,f		;
		movlw	0x00				; ADC_sym_HI =0?
		subwf	ADC_sym_HI,w		;  
		btfss	STATUS,Z			;     Error_auto_set
		goto	Error_auto_set		;
;    Per_lo
		movlw	Per_lo				;   "%"
		call	Calc_percent		; 
		movfw	AARGB1				;
		addwf	ADC_sym_LO,w		;   "%"  ADC_sym_LO	
;    EEPROM
		bsf		STATUS,RP0			;  1
		movwf	EEDATA				;
		movlw	0x00				;
		movwf	EEADR				;		
		bsf		EECON1,WREN			;
		bcf		INTCON,GIE			;
		movlw	0x55				;
		movwf	EECON2				;
		movlw	0xAA				;
		movwf	EECON2				;
		bsf		EECON1,WR			;
AS_wait2							;
		clrwdt						;
		btfsc	EECON1,WR			;
		goto	AS_wait2			;
		bcf		STATUS,RP0			;  0
;====================================
; 
TST_result							;
		clrwdt						;
		movlw	0x00				;   
		call	Read_EEPROM			;  Low->High
		movwf	SP_lo_hi			;
		movlw	0x01				;   
		call	Read_EEPROM			;  High->Low
		subwf	SP_lo_hi,w			;
		btfsc	STATUS,Z			;  "="?
		goto	Error_auto_set		;  ""
		btfsc	STATUS,C			; SP_lo_hi < SP_hi_lo?
		goto	Error_auto_set		;  ""  
		bcf		Auto_setting			;   
		goto	Start				;    
;******************************************************************************
; .   
Error_auto_set						;
		bcf		STATUS,RP0			;  0
		movlw	B'00000000'			;    "000"
		movwf	CMCON				;
		bcf		Gate_VT				;  -
		Ind_HI_on					;    
		call	Delay_250ms			;
		Ind_LO_on					;    
		call	Delay_250ms			;
		goto	Error_auto_set		;
;******************************************************************************
        ORG 0x3FF					;  
        retlw 0x90					; . 
;******************************************************************************
        ORG 0x2100					;  EEPROM
			DE 0x19					;    Low->High (0x0000)
			DE 0x28					;    High->Low (0x0001)
 end								;  